/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.237 Revision 1.382
1# Copyright 1999-2006 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.237 2006/06/04 15:18:12 vapier Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.382 2012/02/14 16:08:54 vapier Exp $
4#
5# This eclass is for general purpose functions that most ebuilds
6# have to implement themselves.
7#
8# NB: If you add anything, please comment it!
9 4
5# @ECLASS: eutils.eclass
6# @MAINTAINER:
7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds
9# @DESCRIPTION:
10# The eutils eclass contains a suite of functions that complement
11# the ones that ebuild.sh already contain. The idea is that the functions
12# are not required in all ebuilds but enough utilize them to have a common
13# home rather than having multiple ebuilds implementing the same thing.
14#
15# Due to the nature of this eclass, some functions may have maintainers
16# different from the overall eclass!
17
18if [[ ${___ECLASS_ONCE_EUTILS} != "recur -_+^+_- spank" ]] ; then
19___ECLASS_ONCE_EUTILS="recur -_+^+_- spank"
20
10inherit multilib portability 21inherit multilib portability user
11
12DEPEND="!bootstrap? ( sys-devel/patch )"
13RDEPEND=""
14# sys-apps/shadow is needed for useradd, etc, bug #94745.
15 22
16DESCRIPTION="Based on the ${ECLASS} eclass" 23DESCRIPTION="Based on the ${ECLASS} eclass"
17 24
18# Wait for the supplied number of seconds. If no argument is supplied, defaults 25if has "${EAPI:-0}" 0 1 2; then
19# to five seconds. If the EPAUSE_IGNORE env var is set, don't wait. If we're not 26
20# outputting to a terminal, don't wait. For compatability purposes, the argument 27# @FUNCTION: epause
21# must be an integer greater than zero. 28# @USAGE: [seconds]
22# Bug 62950, Ciaran McCreesh <ciaranm@gentoo.org> (05 Sep 2004) 29# @DESCRIPTION:
30# Sleep for the specified number of seconds (default of 5 seconds). Useful when
31# printing a message the user should probably be reading and often used in
32# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
33# don't wait at all. Defined in EAPIs 0 1 and 2.
23epause() { 34epause() {
24 if [ -z "$EPAUSE_IGNORE" ] && [ -t 1 ] ; then 35 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
25 sleep ${1:-5}
26 fi
27} 36}
28 37
29# Beep the specified number of times (defaults to five). If our output 38# @FUNCTION: ebeep
30# is not a terminal, don't beep. If the EBEEP_IGNORE env var is set, 39# @USAGE: [number of beeps]
31# don't beep. 40# @DESCRIPTION:
32# Bug 62950, Ciaran McCreesh <ciaranm@gentoo.org> (05 Sep 2004) 41# Issue the specified number of beeps (default of 5 beeps). Useful when
42# printing a message the user should probably be reading and often used in
43# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
44# don't beep at all. Defined in EAPIs 0 1 and 2.
33ebeep() { 45ebeep() {
34 local n 46 local n
35 if [ -z "$EBEEP_IGNORE" ] && [ -t 1 ] ; then 47 if [[ -z ${EBEEP_IGNORE} ]] ; then
36 for ((n=1 ; n <= ${1:-5} ; n++)) ; do 48 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
37 echo -ne "\a" 49 echo -ne "\a"
38 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null 50 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null
39 echo -ne "\a" 51 echo -ne "\a"
40 sleep 1 52 sleep 1
41 done 53 done
42 fi 54 fi
43} 55}
44 56
45# This function generate linker scripts in /usr/lib for dynamic 57else
46# libs in /lib. This is to fix linking problems when you have
47# the .so in /lib, and the .a in /usr/lib. What happens is that
48# in some cases when linking dynamic, the .a in /usr/lib is used
49# instead of the .so in /lib due to gcc/libtool tweaking ld's
50# library search path. This cause many builds to fail.
51# See bug #4411 for more info.
52#
53# To use, simply call:
54#
55# gen_usr_ldscript libfoo.so
56#
57# Note that you should in general use the unversioned name of
58# the library, as ldconfig should usually update it correctly
59# to point to the latest version of the library present.
60#
61# <azarah@gentoo.org> (26 Oct 2002)
62#
63gen_usr_ldscript() {
64 local lib libdir=$(get_libdir)
65 # Just make sure it exists
66 dodir /usr/${libdir}
67 58
68 for lib in "${@}" ; do 59ebeep() {
69 cat > "${D}/usr/${libdir}/${lib}" <<-END_LDSCRIPT 60 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
70 /* GNU ld script 61}
71 Since Gentoo has critical dynamic libraries
72 in /lib, and the static versions in /usr/lib,
73 we need to have a "fake" dynamic lib in /usr/lib,
74 otherwise we run into linking problems.
75 62
76 See bug http://bugs.gentoo.org/4411 for more info. 63epause() {
77 */ 64 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
78 GROUP ( /${libdir}/${lib} ) 65}
79 END_LDSCRIPT 66
80 fperms a+x "/usr/${libdir}/${lib}" || die "could not change perms on ${lib}" 67fi
68
69# @FUNCTION: eqawarn
70# @USAGE: [message]
71# @DESCRIPTION:
72# Proxy to ewarn for package managers that don't provide eqawarn and use the PM
73# implementation if available. Reuses PORTAGE_ELOG_CLASSES as set by the dev
74# profile.
75if ! declare -F eqawarn >/dev/null ; then
76 eqawarn() {
77 has qa ${PORTAGE_ELOG_CLASSES} && ewarn "$@"
78 :
79 }
80fi
81
82# @FUNCTION: ecvs_clean
83# @USAGE: [list of dirs]
84# @DESCRIPTION:
85# Remove CVS directories recursiveley. Useful when a source tarball contains
86# internal CVS directories. Defaults to $PWD.
87ecvs_clean() {
88 [[ -z $* ]] && set -- .
89 find "$@" -type d -name 'CVS' -prune -print0 | xargs -0 rm -rf
90 find "$@" -type f -name '.cvs*' -print0 | xargs -0 rm -rf
91}
92
93# @FUNCTION: esvn_clean
94# @USAGE: [list of dirs]
95# @DESCRIPTION:
96# Remove .svn directories recursiveley. Useful when a source tarball contains
97# internal Subversion directories. Defaults to $PWD.
98esvn_clean() {
99 [[ -z $* ]] && set -- .
100 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
101}
102
103# @FUNCTION: estack_push
104# @USAGE: <stack> [items to push]
105# @DESCRIPTION:
106# Push any number of items onto the specified stack. Pick a name that
107# is a valid variable (i.e. stick to alphanumerics), and push as many
108# items as you like onto the stack at once.
109#
110# The following code snippet will echo 5, then 4, then 3, then ...
111# @CODE
112# estack_push mystack 1 2 3 4 5
113# while estack_pop mystack i ; do
114# echo "${i}"
81 done 115# done
116# @CODE
117estack_push() {
118 [[ $# -eq 0 ]] && die "estack_push: incorrect # of arguments"
119 local stack_name="__ESTACK_$1__" ; shift
120 eval ${stack_name}+=\( \"\$@\" \)
82} 121}
83 122
123# @FUNCTION: estack_pop
124# @USAGE: <stack> [variable]
125# @DESCRIPTION:
126# Pop a single item off the specified stack. If a variable is specified,
127# the popped item is stored there. If no more items are available, return
128# 1, else return 0. See estack_push for more info.
129estack_pop() {
130 [[ $# -eq 0 || $# -gt 2 ]] && die "estack_pop: incorrect # of arguments"
84 131
85# Default directory where patches are located 132 # We use the fugly __estack_xxx var names to avoid collision with
133 # passing back the return value. If we used "local i" and the
134 # caller ran `estack_pop ... i`, we'd end up setting the local
135 # copy of "i" rather than the caller's copy. The __estack_xxx
136 # garbage is preferable to using $1/$2 everywhere as that is a
137 # bit harder to read.
138 local __estack_name="__ESTACK_$1__" ; shift
139 local __estack_retvar=$1 ; shift
140 eval local __estack_i=\${#${__estack_name}\[@\]}
141 # Don't warn -- let the caller interpret this as a failure
142 # or as normal behavior (akin to `shift`)
143 [[ $(( --__estack_i )) -eq -1 ]] && return 1
144
145 if [[ -n ${__estack_retvar} ]] ; then
146 eval ${__estack_retvar}=\"\${${__estack_name}\[${__estack_i}\]}\"
147 fi
148 eval unset ${__estack_name}\[${__estack_i}\]
149}
150
151# @FUNCTION: eshopts_push
152# @USAGE: [options to `set` or `shopt`]
153# @DESCRIPTION:
154# Often times code will want to enable a shell option to change code behavior.
155# Since changing shell options can easily break other pieces of code (which
156# assume the default state), eshopts_push is used to (1) push the current shell
157# options onto a stack and (2) pass the specified arguments to set.
158#
159# If the first argument is '-s' or '-u', we assume you want to call `shopt`
160# rather than `set` as there are some options only available via that.
161#
162# A common example is to disable shell globbing so that special meaning/care
163# may be used with variables/arguments to custom functions. That would be:
164# @CODE
165# eshopts_push -s noglob
166# for x in ${foo} ; do
167# if ...some check... ; then
168# eshopts_pop
169# return 0
170# fi
171# done
172# eshopts_pop
173# @CODE
174eshopts_push() {
175 if [[ $1 == -[su] ]] ; then
176 estack_push eshopts "$(shopt -p)"
177 [[ $# -eq 0 ]] && return 0
178 shopt "$@" || die "${FUNCNAME}: bad options to shopt: $*"
179 else
180 estack_push eshopts $-
181 [[ $# -eq 0 ]] && return 0
182 set "$@" || die "${FUNCNAME}: bad options to set: $*"
183 fi
184}
185
186# @FUNCTION: eshopts_pop
187# @USAGE:
188# @DESCRIPTION:
189# Restore the shell options to the state saved with the corresponding
190# eshopts_push call. See that function for more details.
191eshopts_pop() {
192 local s
193 estack_pop eshopts s || die "${FUNCNAME}: unbalanced push"
194 if [[ ${s} == "shopt -"* ]] ; then
195 eval "${s}" || die "${FUNCNAME}: sanity: invalid shopt options: ${s}"
196 else
197 set +$- || die "${FUNCNAME}: sanity: invalid shell settings: $-"
198 set -${s} || die "${FUNCNAME}: sanity: unable to restore saved shell settings: ${s}"
199 fi
200}
201
202# @FUNCTION: eumask_push
203# @USAGE: <new umask>
204# @DESCRIPTION:
205# Set the umask to the new value specified while saving the previous
206# value onto a stack. Useful for temporarily changing the umask.
207eumask_push() {
208 estack_push eumask "$(umask)"
209 umask "$@" || die "${FUNCNAME}: bad options to umask: $*"
210}
211
212# @FUNCTION: eumask_pop
213# @USAGE:
214# @DESCRIPTION:
215# Restore the previous umask state.
216eumask_pop() {
217 [[ $# -eq 0 ]] || die "${FUNCNAME}: we take no options"
218 local s
219 estack_pop eumask s || die "${FUNCNAME}: unbalanced push"
220 umask ${s} || die "${FUNCNAME}: sanity: could not restore umask: ${s}"
221}
222
223# @VARIABLE: EPATCH_SOURCE
224# @DESCRIPTION:
225# Default directory to search for patches.
86EPATCH_SOURCE="${WORKDIR}/patch" 226EPATCH_SOURCE="${WORKDIR}/patch"
87# Default extension for patches 227# @VARIABLE: EPATCH_SUFFIX
228# @DESCRIPTION:
229# Default extension for patches (do not prefix the period yourself).
88EPATCH_SUFFIX="patch.bz2" 230EPATCH_SUFFIX="patch.bz2"
231# @VARIABLE: EPATCH_OPTS
232# @DESCRIPTION:
89# Default options for patch 233# Default options for patch:
234# @CODE
90# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571 235# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
91# Set --no-backup-if-mismatch so we don't leave '.orig' files behind. 236# --no-backup-if-mismatch - do not leave .orig files behind
92# Set -E to automatically remove empty files. 237# -E - automatically remove empty files
238# @CODE
93EPATCH_OPTS="-g0 -E --no-backup-if-mismatch" 239EPATCH_OPTS="-g0 -E --no-backup-if-mismatch"
240# @VARIABLE: EPATCH_EXCLUDE
241# @DESCRIPTION:
94# List of patches not to apply. Not this is only file names, 242# List of patches not to apply. Note this is only file names,
95# and not the full path .. 243# and not the full path. Globs accepted.
96EPATCH_EXCLUDE="" 244EPATCH_EXCLUDE=""
245# @VARIABLE: EPATCH_SINGLE_MSG
246# @DESCRIPTION:
97# Change the printed message for a single patch. 247# Change the printed message for a single patch.
98EPATCH_SINGLE_MSG="" 248EPATCH_SINGLE_MSG=""
249# @VARIABLE: EPATCH_MULTI_MSG
250# @DESCRIPTION:
99# Change the printed message for multiple patches. 251# Change the printed message for multiple patches.
100EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..." 252EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
101# Force applying bulk patches even if not following the style: 253# @VARIABLE: EPATCH_FORCE
102# 254# @DESCRIPTION:
103# ??_${ARCH}_foo.${EPATCH_SUFFIX} 255# Only require patches to match EPATCH_SUFFIX rather than the extended
104# 256# arch naming style.
105EPATCH_FORCE="no" 257EPATCH_FORCE="no"
106 258
107# This function is for bulk patching, or in theory for just one 259# @FUNCTION: epatch
108# or two patches. 260# @USAGE: [patches] [dirs of patches]
261# @DESCRIPTION:
262# epatch is designed to greatly simplify the application of patches. It can
263# process patch files directly, or directories of patches. The patches may be
264# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
265# the -p option as epatch will automatically attempt -p0 to -p5 until things
266# apply successfully.
109# 267#
110# It should work with .bz2, .gz, .zip and plain text patches. 268# If you do not specify any options, then epatch will default to the directory
111# Currently all patches should be the same format. 269# specified by EPATCH_SOURCE.
112# 270#
113# You do not have to specify '-p' option to patch, as it will 271# When processing directories, epatch will apply all patches that match:
114# try with -p0 to -p5 until it succeed, or fail at -p5. 272# @CODE
115# 273# if ${EPATCH_FORCE} != "yes"
116# Above EPATCH_* variables can be used to control various defaults,
117# bug they should be left as is to ensure an ebuild can rely on
118# them for.
119#
120# Patches are applied in current directory.
121#
122# Bulk Patches should preferibly have the form of:
123#
124# ??_${ARCH}_foo.${EPATCH_SUFFIX} 274# ??_${ARCH}_foo.${EPATCH_SUFFIX}
275# else
276# *.${EPATCH_SUFFIX}
277# @CODE
278# The leading ?? are typically numbers used to force consistent patch ordering.
279# The arch field is used to apply patches only for the host architecture with
280# the special value of "all" means apply for everyone. Note that using values
281# other than "all" is highly discouraged -- you should apply patches all the
282# time and let architecture details be detected at configure/compile time.
125# 283#
126# For example: 284# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
285# for patches to apply.
127# 286#
128# 01_all_misc-fix.patch.bz2 287# Refer to the other EPATCH_xxx variables for more customization of behavior.
129# 02_sparc_another-fix.patch.bz2
130#
131# This ensures that there are a set order, and you can have ARCH
132# specific patches.
133#
134# If you however give an argument to epatch(), it will treat it as a
135# single patch that need to be applied if its a file. If on the other
136# hand its a directory, it will set EPATCH_SOURCE to this.
137#
138# <azarah@gentoo.org> (10 Nov 2002)
139#
140epatch() { 288epatch() {
141 _epatch_draw_line() { 289 _epatch_draw_line() {
290 # create a line of same length as input string
142 [[ -z $1 ]] && set "$(printf "%65s" '')" 291 [[ -z $1 ]] && set "$(printf "%65s" '')"
143 echo "${1//?/=}" 292 echo "${1//?/=}"
144 } 293 }
145 _epatch_assert() { local _pipestatus=${PIPESTATUS[*]}; [[ ${_pipestatus// /} -eq 0 ]] ; }
146 local PIPE_CMD=""
147 local STDERR_TARGET="${T}/$$.out"
148 local PATCH_TARGET="${T}/$$.patch"
149 local PATCH_SUFFIX=""
150 local SINGLE_PATCH="no"
151 local x=""
152 294
153 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402 295 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
154 296
155 if [ "$#" -gt 1 ] 297 # Let the rest of the code process one user arg at a time --
156 then 298 # each arg may expand into multiple patches, and each arg may
299 # need to start off with the default global EPATCH_xxx values
300 if [[ $# -gt 1 ]] ; then
157 local m="" 301 local m
158 for m in "$@" ; do 302 for m in "$@" ; do
159 epatch "${m}" 303 epatch "${m}"
160 done 304 done
161 return 0 305 return 0
162 fi 306 fi
163 307
164 if [ -n "$1" -a -f "$1" ] 308 local SINGLE_PATCH="no"
165 then 309 # no args means process ${EPATCH_SOURCE}
310 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
311
312 if [[ -f $1 ]] ; then
166 SINGLE_PATCH="yes" 313 SINGLE_PATCH="yes"
167 314 set -- "$1"
168 local EPATCH_SOURCE="$1" 315 # Use the suffix from the single patch (localize it); the code
316 # below will find the suffix for us
169 local EPATCH_SUFFIX="${1##*\.}" 317 local EPATCH_SUFFIX=$1
170 318
171 elif [ -n "$1" -a -d "$1" ] 319 elif [[ -d $1 ]] ; then
172 then 320 # Some people like to make dirs of patches w/out suffixes (vim)
173 # Allow no extension if EPATCH_FORCE=yes ... used by vim for example ... 321 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
174 if [ "${EPATCH_FORCE}" = "yes" ] && [ -z "${EPATCH_SUFFIX}" ] 322
323 elif [[ -f ${EPATCH_SOURCE}/$1 ]] ; then
324 # Re-use EPATCH_SOURCE as a search dir
325 epatch "${EPATCH_SOURCE}/$1"
326 return $?
327
328 else
329 # sanity check ... if it isn't a dir or file, wtf man ?
330 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
331 echo
332 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
333 eerror
334 eerror " ${EPATCH_SOURCE}"
335 eerror " ( ${EPATCH_SOURCE##*/} )"
336 echo
337 die "Cannot find \$EPATCH_SOURCE!"
338 fi
339
340 local PIPE_CMD
341 case ${EPATCH_SUFFIX##*\.} in
342 xz) PIPE_CMD="xz -dc" ;;
343 lzma) PIPE_CMD="lzma -dc" ;;
344 bz2) PIPE_CMD="bzip2 -dc" ;;
345 gz|Z|z) PIPE_CMD="gzip -dc" ;;
346 ZIP|zip) PIPE_CMD="unzip -p" ;;
347 *) ;;
348 esac
349
350 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
351
352 local x
353 for x in "$@" ; do
354 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
355 # didn't match anything, ignore continue on
356 [[ ! -f ${x} ]] && continue
357
358 local patchname=${x##*/}
359
360 # Apply single patches, or forced sets of patches, or
361 # patches with ARCH dependant names.
362 # ???_arch_foo.patch
363 # Else, skip this input altogether
364 local a=${patchname#*_} # strip the ???_
365 a=${a%%_*} # strip the _foo.patch
366 if ! [[ ${SINGLE_PATCH} == "yes" || \
367 ${EPATCH_FORCE} == "yes" || \
368 ${a} == all || \
369 ${a} == ${ARCH} ]]
175 then 370 then
176 local EPATCH_SOURCE="$1/*" 371 continue
372 fi
373
374 # Let people filter things dynamically
375 if [[ -n ${EPATCH_EXCLUDE} ]] ; then
376 # let people use globs in the exclude
377 eshopts_push -o noglob
378
379 local ex
380 for ex in ${EPATCH_EXCLUDE} ; do
381 if [[ ${patchname} == ${ex} ]] ; then
382 eshopts_pop
383 continue 2
384 fi
385 done
386
387 eshopts_pop
388 fi
389
390 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
391 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
392 einfo "${EPATCH_SINGLE_MSG}"
393 else
394 einfo "Applying ${patchname} ..."
395 fi
177 else 396 else
178 local EPATCH_SOURCE="$1/*.${EPATCH_SUFFIX}" 397 einfo " ${patchname} ..."
179 fi 398 fi
180 else 399
181 if [ ! -d ${EPATCH_SOURCE} ] || [ -n "$1" ] 400 # most of the time, there will only be one run per unique name,
182 then 401 # but if there are more, make sure we get unique log filenames
183 if [ -n "$1" -a "${EPATCH_SOURCE}" = "${WORKDIR}/patch" ] 402 local STDERR_TARGET="${T}/${patchname}.out"
184 then 403 if [[ -e ${STDERR_TARGET} ]] ; then
185 EPATCH_SOURCE="$1" 404 STDERR_TARGET="${T}/${patchname}-$$.out"
405 fi
406
407 printf "***** %s *****\nPWD: %s\n\n" "${patchname}" "${PWD}" > "${STDERR_TARGET}"
408
409 # Decompress the patch if need be
410 local count=0
411 local PATCH_TARGET
412 if [[ -n ${PIPE_CMD} ]] ; then
413 PATCH_TARGET="${T}/$$.patch"
414 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
415
416 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
417 echo
418 eerror "Could not extract patch!"
419 #die "Could not extract patch!"
420 count=5
421 break
186 fi 422 fi
423 else
424 PATCH_TARGET=${x}
425 fi
187 426
427 # Check for absolute paths in patches. If sandbox is disabled,
428 # people could (accidently) patch files in the root filesystem.
429 # Or trigger other unpleasantries #237667. So disallow -p0 on
430 # such patches.
431 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
432 if [[ -n ${abs_paths} ]] ; then
433 count=1
434 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
435 fi
436 # Similar reason, but with relative paths.
437 local rel_paths=$(egrep -n '^[-+]{3} [^ ]*[.][.]/' "${PATCH_TARGET}")
438 if [[ -n ${rel_paths} ]] ; then
439 eqawarn "QA Notice: Your patch uses relative paths '../'."
440 eqawarn " In the future this will cause a failure."
441 eqawarn "${rel_paths}"
442 fi
443
444 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
445 while [[ ${count} -lt 5 ]] ; do
446 # Generate some useful debug info ...
447 (
448 _epatch_draw_line "***** ${patchname} *****"
188 echo 449 echo
189 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:" 450 echo "PATCH COMMAND: patch -p${count} ${EPATCH_OPTS} < '${PATCH_TARGET}'"
451 echo
452 _epatch_draw_line "***** ${patchname} *****"
453 patch -p${count} ${EPATCH_OPTS} --dry-run -f < "${PATCH_TARGET}" 2>&1
454 ret=$?
455 echo
456 echo "patch program exited with status ${ret}"
457 exit ${ret}
458 ) >> "${STDERR_TARGET}"
459
460 if [ $? -eq 0 ] ; then
461 (
462 _epatch_draw_line "***** ${patchname} *****"
463 echo
464 echo "ACTUALLY APPLYING ${patchname} ..."
465 echo
466 _epatch_draw_line "***** ${patchname} *****"
467 patch -p${count} ${EPATCH_OPTS} < "${PATCH_TARGET}" 2>&1
468 ret=$?
469 echo
470 echo "patch program exited with status ${ret}"
471 exit ${ret}
472 ) >> "${STDERR_TARGET}"
473
474 if [ $? -ne 0 ] ; then
475 echo
476 eerror "A dry-run of patch command succeeded, but actually"
477 eerror "applying the patch failed!"
478 #die "Real world sux compared to the dreamworld!"
479 count=5
480 fi
481 break
482 fi
483
484 : $(( count++ ))
485 done
486
487 # if we had to decompress the patch, delete the temp one
488 if [[ -n ${PIPE_CMD} ]] ; then
489 rm -f "${PATCH_TARGET}"
490 fi
491
492 if [[ ${count} -ge 5 ]] ; then
493 echo
494 eerror "Failed Patch: ${patchname} !"
495 eerror " ( ${PATCH_TARGET} )"
190 eerror 496 eerror
191 eerror " ${EPATCH_SOURCE}" 497 eerror "Include in your bugreport the contents of:"
192 eerror " ( ${EPATCH_SOURCE##*/} )" 498 eerror
499 eerror " ${STDERR_TARGET}"
193 echo 500 echo
194 die "Cannot find \$EPATCH_SOURCE!"
195 fi
196
197 local EPATCH_SOURCE="${EPATCH_SOURCE}/*.${EPATCH_SUFFIX}"
198 fi
199
200 case ${EPATCH_SUFFIX##*\.} in
201 bz2)
202 PIPE_CMD="bzip2 -dc"
203 PATCH_SUFFIX="bz2"
204 ;;
205 gz|Z|z)
206 PIPE_CMD="gzip -dc"
207 PATCH_SUFFIX="gz"
208 ;;
209 ZIP|zip)
210 PIPE_CMD="unzip -p"
211 PATCH_SUFFIX="zip"
212 ;;
213 *)
214 PIPE_CMD="cat"
215 PATCH_SUFFIX="patch"
216 ;;
217 esac
218
219 if [ "${SINGLE_PATCH}" = "no" ]
220 then
221 einfo "${EPATCH_MULTI_MSG}"
222 fi
223 for x in ${EPATCH_SOURCE}
224 do
225 # New ARCH dependant patch naming scheme ...
226 #
227 # ???_arch_foo.patch
228 #
229 if [ -f ${x} ] && \
230 ([ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "${x/_${ARCH}_}" != "${x}" ] || \
231 [ "${EPATCH_FORCE}" = "yes" ])
232 then
233 local count=0
234 local popts="${EPATCH_OPTS}"
235 local patchname=${x##*/}
236
237 if [ -n "${EPATCH_EXCLUDE}" ]
238 then
239 if [ "${EPATCH_EXCLUDE/${patchname}}" != "${EPATCH_EXCLUDE}" ]
240 then
241 continue
242 fi
243 fi
244
245 if [ "${SINGLE_PATCH}" = "yes" ]
246 then
247 if [ -n "${EPATCH_SINGLE_MSG}" ]
248 then
249 einfo "${EPATCH_SINGLE_MSG}"
250 else
251 einfo "Applying ${patchname} ..."
252 fi
253 else
254 einfo " ${patchname} ..."
255 fi
256
257 echo "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
258 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
259
260 # Allow for prefix to differ ... im lazy, so shoot me :/
261 while [ "${count}" -lt 5 ]
262 do
263 # Generate some useful debug info ...
264 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
265 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
266
267 if [ "${PATCH_SUFFIX}" != "patch" ]
268 then
269 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
270 echo "${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
271 else
272 PATCH_TARGET="${x}"
273 fi
274
275 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
276 echo "patch -p${count} ${popts} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
277
278 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
279 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
280
281 if [ "${PATCH_SUFFIX}" != "patch" ]
282 then
283 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
284 then
285 echo
286 eerror "Could not extract patch!"
287 #die "Could not extract patch!"
288 count=5
289 break
290 fi
291 fi
292
293 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f ; _epatch_assert) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
294 then
295 _epatch_draw_line "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
296 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
297 echo "ACTUALLY APPLYING ${patchname} ..." >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
298 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
299 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
300
301 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 2>&1
302 _epatch_assert
303
304 if [ "$?" -ne 0 ]
305 then
306 cat ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
307 echo
308 eerror "A dry-run of patch command succeeded, but actually"
309 eerror "applying the patch failed!"
310 #die "Real world sux compared to the dreamworld!"
311 count=5
312 fi
313
314 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
315
316 break
317 fi
318
319 count=$((count + 1))
320 done
321
322 if [ "${PATCH_SUFFIX}" != "patch" ]
323 then
324 rm -f ${PATCH_TARGET}
325 fi
326
327 if [ "${count}" -eq 5 ]
328 then
329 echo
330 eerror "Failed Patch: ${patchname} !"
331 eerror " ( ${PATCH_TARGET} )"
332 eerror
333 eerror "Include in your bugreport the contents of:"
334 eerror
335 eerror " ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}"
336 echo
337 die "Failed Patch: ${patchname}!" 501 die "Failed Patch: ${patchname}!"
338 fi 502 fi
339 503
340 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 504 # if everything worked, delete the patch log
341 505 rm -f "${STDERR_TARGET}"
342 eend 0 506 eend 0
343 fi
344 done 507 done
345 if [ "${SINGLE_PATCH}" = "no" ] 508
346 then 509 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
347 einfo "Done with patching" 510 : # everything worked
511}
512
513# @FUNCTION: epatch_user
514# @USAGE:
515# @DESCRIPTION:
516# Applies user-provided patches to the source tree. The patches are
517# taken from /etc/portage/patches/<CATEGORY>/<PF|P|PN>/, where the first
518# of these three directories to exist will be the one to use, ignoring
519# any more general directories which might exist as well.
520#
521# User patches are intended for quick testing of patches without ebuild
522# modifications, as well as for permanent customizations a user might
523# desire. Obviously, there can be no official support for arbitrarily
524# patched ebuilds. So whenever a build log in a bug report mentions that
525# user patches were applied, the user should be asked to reproduce the
526# problem without these.
527#
528# Not all ebuilds do call this function, so placing patches in the
529# stated directory might or might not work, depending on the package and
530# the eclasses it inherits and uses. It is safe to call the function
531# repeatedly, so it is always possible to add a call at the ebuild
532# level. The first call is the time when the patches will be
533# applied.
534#
535# Ideally, this function should be called after gentoo-specific patches
536# have been applied, so that their code can be modified as well, but
537# before calls to e.g. eautoreconf, as the user patches might affect
538# autotool input files as well.
539epatch_user() {
540 [[ $# -ne 0 ]] && die "epatch_user takes no options"
541
542 # Allow multiple calls to this function; ignore all but the first
543 local applied="${T}/epatch_user.applied"
544 [[ -e ${applied} ]] && return 2
545
546 # don't clobber any EPATCH vars that the parent might want
547 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
548 for check in ${CATEGORY}/{${P}-${PR},${P},${PN}}; do
549 EPATCH_SOURCE=${base}/${CTARGET}/${check}
550 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
551 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
552 if [[ -d ${EPATCH_SOURCE} ]] ; then
553 EPATCH_SOURCE=${EPATCH_SOURCE} \
554 EPATCH_SUFFIX="patch" \
555 EPATCH_FORCE="yes" \
556 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
557 epatch
558 echo "${EPATCH_SOURCE}" > "${applied}"
559 return 0
348 fi 560 fi
561 done
562 echo "none" > "${applied}"
563 return 1
349} 564}
350 565
566# @FUNCTION: emktemp
567# @USAGE: [temp dir]
568# @DESCRIPTION:
351# Cheap replacement for when debianutils (and thus mktemp) 569# Cheap replacement for when debianutils (and thus mktemp)
352# does not exist on the users system 570# does not exist on the users system.
353# vapier@gentoo.org
354#
355# Takes just 1 optional parameter (the directory to create tmpfile in)
356emktemp() { 571emktemp() {
357 local exe="touch" 572 local exe="touch"
358 [[ $1 == -d ]] && exe="mkdir" && shift 573 [[ $1 == -d ]] && exe="mkdir" && shift
359 local topdir=$1 574 local topdir=$1
360 575
362 [[ -z ${T} ]] \ 577 [[ -z ${T} ]] \
363 && topdir="/tmp" \ 578 && topdir="/tmp" \
364 || topdir=${T} 579 || topdir=${T}
365 fi 580 fi
366 581
367 if [[ -z $(type -p mktemp) ]] ; then 582 if ! type -P mktemp > /dev/null ; then
583 # system lacks `mktemp` so we have to fake it
368 local tmp=/ 584 local tmp=/
369 while [[ -e ${tmp} ]] ; do 585 while [[ -e ${tmp} ]] ; do
370 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM} 586 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}
371 done 587 done
372 ${exe} "${tmp}" || ${exe} -p "${tmp}" 588 ${exe} "${tmp}" || ${exe} -p "${tmp}"
373 echo "${tmp}" 589 echo "${tmp}"
374 else 590 else
591 # the args here will give slightly wierd names on BSD,
592 # but should produce a usable file on all userlands
375 if [[ ${exe} == "touch" ]] ; then 593 if [[ ${exe} == "touch" ]] ; then
376 [[ ${USERLAND} == "GNU" ]] \
377 && mktemp -p "${topdir}" \
378 || TMPDIR="${topdir}" mktemp -t tmp 594 TMPDIR="${topdir}" mktemp -t tmp.XXXXXXXXXX
379 else 595 else
380 [[ ${USERLAND} == "GNU" ]] \
381 && mktemp -d "${topdir}" \
382 || TMPDIR="${topdir}" mktemp -dt tmp 596 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
383 fi
384 fi
385}
386
387# Small wrapper for getent (Linux), nidump (Mac OS X),
388# and pw (FreeBSD) used in enewuser()/enewgroup()
389# Joe Jezak <josejx@gmail.com> and usata@gentoo.org
390# FBSD stuff: Aaron Walker <ka0ttic@gentoo.org>
391#
392# egetent(database, key)
393egetent() {
394 case ${CHOST} in
395 *-darwin*)
396 case "$2" in
397 *[!0-9]*) # Non numeric
398 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }"
399 ;;
400 *) # Numeric
401 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
402 ;;
403 esac
404 ;;
405 *-freebsd*|*-dragonfly*)
406 local opts action="user"
407 [[ $1 == "passwd" ]] || action="group"
408
409 # lookup by uid/gid
410 if [[ $2 == [[:digit:]]* ]] ; then
411 [[ ${action} == "user" ]] && opts="-u" || opts="-g"
412 fi
413
414 pw show ${action} ${opts} "$2" -q
415 ;;
416 *-netbsd*|*-openbsd*)
417 grep "$2:\*:" /etc/$1
418 ;;
419 *)
420 type -p nscd >& /dev/null && nscd -i "$1"
421 getent "$1" "$2"
422 ;;
423 esac
424}
425
426# Simplify/standardize adding users to the system
427# vapier@gentoo.org
428#
429# enewuser(username, uid, shell, homedir, groups, extra options)
430#
431# Default values if you do not specify any:
432# username: REQUIRED !
433# uid: next available (see useradd(8))
434# note: pass -1 to get default behavior
435# shell: /bin/false
436# homedir: /dev/null
437# groups: none
438# extra: comment of 'added by portage for ${PN}'
439enewuser() {
440 case ${EBUILD_PHASE} in
441 unpack|compile|test|install)
442 eerror "'enewuser()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
443 eerror "Package fails at QA and at life. Please file a bug."
444 die "Bad package! enewuser is only for use in pkg_* functions!"
445 esac
446
447 # get the username
448 local euser=$1; shift
449 if [[ -z ${euser} ]] ; then
450 eerror "No username specified !"
451 die "Cannot call enewuser without a username"
452 fi
453
454 # lets see if the username already exists
455 if [[ ${euser} == $(egetent passwd "${euser}" | cut -d: -f1) ]] ; then
456 return 0
457 fi
458 einfo "Adding user '${euser}' to your system ..."
459
460 # options to pass to useradd
461 local opts=
462
463 # handle uid
464 local euid=$1; shift
465 if [[ ! -z ${euid} ]] && [[ ${euid} != "-1" ]] ; then
466 if [[ ${euid} -gt 0 ]] ; then
467 if [[ ! -z $(egetent passwd ${euid}) ]] ; then
468 euid="next"
469 fi 597 fi
470 else
471 eerror "Userid given but is not greater than 0 !"
472 die "${euid} is not a valid UID"
473 fi 598 fi
474 else
475 euid="next"
476 fi
477 if [[ ${euid} == "next" ]] ; then
478 for euid in $(seq 101 999) ; do
479 [[ -z $(egetent passwd ${euid}) ]] && break
480 done
481 fi
482 opts="${opts} -u ${euid}"
483 einfo " - Userid: ${euid}"
484
485 # handle shell
486 local eshell=$1; shift
487 if [[ ! -z ${eshell} ]] && [[ ${eshell} != "-1" ]] ; then
488 if [[ ! -e ${ROOT}${eshell} ]] ; then
489 eerror "A shell was specified but it does not exist !"
490 die "${eshell} does not exist in ${ROOT}"
491 fi
492 if [[ ${eshell} == */false || ${eshell} == */nologin ]] ; then
493 eerror "Do not specify ${eshell} yourself, use -1"
494 die "Pass '-1' as the shell parameter"
495 fi
496 else
497 for shell in /sbin/nologin /usr/sbin/nologin /bin/false /usr/bin/false /dev/null ; do
498 [[ -x ${ROOT}${shell} ]] && break
499 done
500
501 if [[ ${shell} == "/dev/null" ]] ; then
502 eerror "Unable to identify the shell to use"
503 die "Unable to identify the shell to use"
504 fi
505
506 eshell=${shell}
507 fi
508 einfo " - Shell: ${eshell}"
509 opts="${opts} -s ${eshell}"
510
511 # handle homedir
512 local ehome=$1; shift
513 if [[ -z ${ehome} ]] || [[ ${ehome} == "-1" ]] ; then
514 ehome="/dev/null"
515 fi
516 einfo " - Home: ${ehome}"
517 opts="${opts} -d ${ehome}"
518
519 # handle groups
520 local egroups=$1; shift
521 if [[ ! -z ${egroups} ]] ; then
522 local oldifs=${IFS}
523 local defgroup="" exgroups=""
524
525 export IFS=","
526 for g in ${egroups} ; do
527 export IFS=${oldifs}
528 if [[ -z $(egetent group "${g}") ]] ; then
529 eerror "You must add group ${g} to the system first"
530 die "${g} is not a valid GID"
531 fi
532 if [[ -z ${defgroup} ]] ; then
533 defgroup=${g}
534 else
535 exgroups="${exgroups},${g}"
536 fi
537 export IFS=","
538 done
539 export IFS=${oldifs}
540
541 opts="${opts} -g ${defgroup}"
542 if [[ ! -z ${exgroups} ]] ; then
543 opts="${opts} -G ${exgroups:1}"
544 fi
545 else
546 egroups="(none)"
547 fi
548 einfo " - Groups: ${egroups}"
549
550 # handle extra and add the user
551 local oldsandbox=${SANDBOX_ON}
552 export SANDBOX_ON="0"
553 case ${CHOST} in
554 *-darwin*)
555 ### Make the user
556 if [[ -z $@ ]] ; then
557 dscl . create /users/${euser} uid ${euid}
558 dscl . create /users/${euser} shell ${eshell}
559 dscl . create /users/${euser} home ${ehome}
560 dscl . create /users/${euser} realname "added by portage for ${PN}"
561 ### Add the user to the groups specified
562 local oldifs=${IFS}
563 export IFS=","
564 for g in ${egroups} ; do
565 dscl . merge /groups/${g} users ${euser}
566 done
567 export IFS=${oldifs}
568 else
569 einfo "Extra options are not supported on Darwin yet"
570 einfo "Please report the ebuild along with the info below"
571 einfo "eextra: $@"
572 die "Required function missing"
573 fi
574 ;;
575 *-freebsd*|*-dragonfly*)
576 if [[ -z $@ ]] ; then
577 pw useradd ${euser} ${opts} \
578 -c "added by portage for ${PN}" \
579 die "enewuser failed"
580 else
581 einfo " - Extra: $@"
582 pw useradd ${euser} ${opts} \
583 "$@" || die "enewuser failed"
584 fi
585 ;;
586
587 *-netbsd*)
588 if [[ -z $@ ]] ; then
589 useradd ${opts} ${euser} || die "enewuser failed"
590 else
591 einfo " - Extra: $@"
592 useradd ${opts} ${euser} "$@" || die "enewuser failed"
593 fi
594 ;;
595
596 *-openbsd*)
597 if [[ -z $@ ]] ; then
598 useradd -u ${euid} -s ${eshell} \
599 -d ${ehome} -c "Added by portage for ${PN}" \
600 -g ${egroups} ${euser} || die "enewuser failed"
601 else
602 einfo " - Extra: $@"
603 useradd -u ${euid} -s ${eshell} \
604 -d ${ehome} -c "Added by portage for ${PN}" \
605 -g ${egroups} ${euser} "$@" || die "enewuser failed"
606 fi
607 ;;
608
609 *)
610 if [[ -z $@ ]] ; then
611 useradd ${opts} ${euser} \
612 -c "added by portage for ${PN}" \
613 || die "enewuser failed"
614 else
615 einfo " - Extra: $@"
616 useradd ${opts} ${euser} "$@" \
617 || die "enewuser failed"
618 fi
619 ;;
620 esac
621
622 if [[ ! -e ${ROOT}/${ehome} ]] ; then
623 einfo " - Creating ${ehome} in ${ROOT}"
624 mkdir -p "${ROOT}/${ehome}"
625 chown ${euser} "${ROOT}/${ehome}"
626 chmod 755 "${ROOT}/${ehome}"
627 fi
628
629 export SANDBOX_ON=${oldsandbox}
630} 599}
631 600
632# Simplify/standardize adding groups to the system 601# @FUNCTION: edos2unix
633# vapier@gentoo.org 602# @USAGE: <file> [more files ...]
634# 603# @DESCRIPTION:
635# enewgroup(group, gid) 604# A handy replacement for dos2unix, recode, fixdos, etc... This allows you
636# 605# to remove all of these text utilities from DEPEND variables because this
637# Default values if you do not specify any: 606# is a script based solution. Just give it a list of files to convert and
638# groupname: REQUIRED ! 607# they will all be changed from the DOS CRLF format to the UNIX LF format.
639# gid: next available (see groupadd(8))
640# extra: none
641enewgroup() {
642 case ${EBUILD_PHASE} in
643 unpack|compile|test|install)
644 eerror "'enewgroup()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
645 eerror "Package fails at QA and at life. Please file a bug."
646 die "Bad package! enewgroup is only for use in pkg_* functions!"
647 esac
648
649 # get the group
650 local egroup="$1"; shift
651 if [ -z "${egroup}" ]
652 then
653 eerror "No group specified !"
654 die "Cannot call enewgroup without a group"
655 fi
656
657 # see if group already exists
658 if [ "${egroup}" == "`egetent group \"${egroup}\" | cut -d: -f1`" ]
659 then
660 return 0
661 fi
662 einfo "Adding group '${egroup}' to your system ..."
663
664 # options to pass to useradd
665 local opts=
666
667 # handle gid
668 local egid="$1"; shift
669 if [ ! -z "${egid}" ]
670 then
671 if [ "${egid}" -gt 0 ]
672 then
673 if [ -z "`egetent group ${egid}`" ]
674 then
675 if [[ "${CHOST}" == *-darwin* ]]; then
676 opts="${opts} ${egid}"
677 else
678 opts="${opts} -g ${egid}"
679 fi
680 else
681 egid="next available; requested gid taken"
682 fi
683 else
684 eerror "Groupid given but is not greater than 0 !"
685 die "${egid} is not a valid GID"
686 fi
687 else
688 egid="next available"
689 fi
690 einfo " - Groupid: ${egid}"
691
692 # handle extra
693 local eextra="$@"
694 opts="${opts} ${eextra}"
695
696 # add the group
697 local oldsandbox="${SANDBOX_ON}"
698 export SANDBOX_ON="0"
699 case ${CHOST} in
700 *-darwin*)
701 if [ ! -z "${eextra}" ];
702 then
703 einfo "Extra options are not supported on Darwin/OS X yet"
704 einfo "Please report the ebuild along with the info below"
705 einfo "eextra: ${eextra}"
706 die "Required function missing"
707 fi
708
709 # If we need the next available
710 case ${egid} in
711 *[!0-9]*) # Non numeric
712 for egid in $(seq 101 999); do
713 [ -z "`egetent group ${egid}`" ] && break
714 done
715 esac
716 dscl . create /groups/${egroup} gid ${egid}
717 dscl . create /groups/${egroup} passwd '*'
718 ;;
719
720 *-freebsd*|*-dragonfly*)
721 case ${egid} in
722 *[!0-9]*) # Non numeric
723 for egid in $(seq 101 999); do
724 [ -z "`egetent group ${egid}`" ] && break
725 done
726 esac
727 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed"
728 ;;
729
730 *-netbsd*)
731 case ${egid} in
732 *[!0-9]*) # Non numeric
733 for egid in $(seq 101 999); do
734 [ -z "`egetent group ${egid}`" ] && break
735 done
736 esac
737 groupadd -g ${egid} ${egroup} || die "enewgroup failed"
738 ;;
739
740 *)
741 groupadd ${opts} ${egroup} || die "enewgroup failed"
742 ;;
743 esac
744 export SANDBOX_ON="${oldsandbox}"
745}
746
747# Simple script to replace 'dos2unix' binaries
748# vapier@gentoo.org
749#
750# edos2unix(file, <more files> ...)
751edos2unix() { 608edos2unix() {
752 for f in "$@" 609 [[ $# -eq 0 ]] && return 0
753 do 610 sed -i 's/\r$//' -- "$@" || die
754 cp "${f}" ${T}/edos2unix
755 sed 's/\r$//' ${T}/edos2unix > "${f}"
756 done
757} 611}
758 612
759 613# @FUNCTION: make_desktop_entry
760############################################################## 614# @USAGE: make_desktop_entry(<command>, [name], [icon], [type], [fields])
761# START: Handle .desktop files and menu entries # 615# @DESCRIPTION:
762# maybe this should be separated into a new eclass some time #
763# lanius@gentoo.org #
764##############################################################
765
766# Make a desktop file ! 616# Make a .desktop file.
767# Great for making those icons in kde/gnome startmenu !
768# Amaze your friends ! Get the women ! Join today !
769# 617#
770# make_desktop_entry(<binary>, [name], [icon], [type], [path]) 618# @CODE
771#
772# binary: what binary does the app run with ? 619# binary: what command does the app run with ?
773# name: the name that will show up in the menu 620# name: the name that will show up in the menu
774# icon: give your little like a pretty little icon ... 621# icon: give your little like a pretty little icon ...
775# this can be relative (to /usr/share/pixmaps) or 622# this can be relative (to /usr/share/pixmaps) or
776# a full path to an icon 623# a full path to an icon
777# type: what kind of application is this ? for categories: 624# type: what kind of application is this?
778# http://www.freedesktop.org/Standards/desktop-entry-spec 625# for categories:
779# path: if your app needs to startup in a specific dir 626# http://standards.freedesktop.org/menu-spec/latest/apa.html
627# if unset, function tries to guess from package's category
628# fields: extra fields to append to the desktop file; a printf string
629# @CODE
780make_desktop_entry() { 630make_desktop_entry() {
781 [[ -z $1 ]] && eerror "make_desktop_entry: You must specify the executable" && return 1 631 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
782 632
783 local exec=${1} 633 local exec=${1}
784 local name=${2:-${PN}} 634 local name=${2:-${PN}}
785 local icon=${3:-${PN}.png} 635 local icon=${3:-${PN}}
786 local type=${4} 636 local type=${4}
787 local path=${5} 637 local fields=${5}
788 638
789 if [[ -z ${type} ]] ; then 639 if [[ -z ${type} ]] ; then
790 local catmaj=${CATEGORY%%-*} 640 local catmaj=${CATEGORY%%-*}
791 local catmin=${CATEGORY##*-} 641 local catmin=${CATEGORY##*-}
792 case ${catmaj} in 642 case ${catmaj} in
793 app) 643 app)
794 case ${catmin} in 644 case ${catmin} in
645 accessibility) type=Accessibility;;
795 admin) type=System;; 646 admin) type=System;;
647 antivirus) type=System;;
648 arch) type=Archiving;;
649 backup) type=Archiving;;
796 cdr) type=DiscBurning;; 650 cdr) type=DiscBurning;;
797 dicts) type=Dictionary;; 651 dicts) type=Dictionary;;
652 doc) type=Documentation;;
798 editors) type=TextEditor;; 653 editors) type=TextEditor;;
799 emacs) type=TextEditor;; 654 emacs) type=TextEditor;;
800 emulation) type=Emulator;; 655 emulation) type=Emulator;;
801 laptop) type=HardwareSettings;; 656 laptop) type=HardwareSettings;;
802 office) type=Office;; 657 office) type=Office;;
658 pda) type=PDA;;
803 vim) type=TextEditor;; 659 vim) type=TextEditor;;
804 xemacs) type=TextEditor;; 660 xemacs) type=TextEditor;;
805 *) type=;;
806 esac 661 esac
807 ;; 662 ;;
808 663
809 dev) 664 dev)
810 type="Development" 665 type="Development"
811 ;; 666 ;;
812 667
813 games) 668 games)
814 case ${catmin} in 669 case ${catmin} in
815 action) type=ActionGame;; 670 action|fps) type=ActionGame;;
816 arcade) type=ArcadeGame;; 671 arcade) type=ArcadeGame;;
817 board) type=BoardGame;; 672 board) type=BoardGame;;
818 kid) type=KidsGame;;
819 emulation) type=Emulator;; 673 emulation) type=Emulator;;
674 kids) type=KidsGame;;
820 puzzle) type=LogicGame;; 675 puzzle) type=LogicGame;;
676 roguelike) type=RolePlaying;;
821 rpg) type=RolePlaying;; 677 rpg) type=RolePlaying;;
822 roguelike) type=RolePlaying;;
823 simulation) type=Simulation;; 678 simulation) type=Simulation;;
824 sports) type=SportsGame;; 679 sports) type=SportsGame;;
825 strategy) type=StrategyGame;; 680 strategy) type=StrategyGame;;
826 *) type=;;
827 esac 681 esac
828 type="Game;${type}" 682 type="Game;${type}"
829 ;; 683 ;;
830 684
685 gnome)
686 type="Gnome;GTK"
687 ;;
688
689 kde)
690 type="KDE;Qt"
691 ;;
692
831 mail) 693 mail)
832 type="Network;Email" 694 type="Network;Email"
833 ;; 695 ;;
834 696
835 media) 697 media)
836 case ${catmin} in 698 case ${catmin} in
699 gfx)
837 gfx) type=Graphics;; 700 type=Graphics
701 ;;
702 *)
703 case ${catmin} in
838 radio) type=Tuner;; 704 radio) type=Tuner;;
839 sound) type=Audio;; 705 sound) type=Audio;;
840 tv) type=TV;; 706 tv) type=TV;;
841 video) type=Video;; 707 video) type=Video;;
842 *) type=;; 708 esac
709 type="AudioVideo;${type}"
710 ;;
843 esac 711 esac
844 type="AudioVideo;${type}"
845 ;; 712 ;;
846 713
847 net) 714 net)
848 case ${catmin} in 715 case ${catmin} in
849 dialup) type=Dialup;; 716 dialup) type=Dialup;;
852 irc) type=IRCClient;; 719 irc) type=IRCClient;;
853 mail) type=Email;; 720 mail) type=Email;;
854 news) type=News;; 721 news) type=News;;
855 nntp) type=News;; 722 nntp) type=News;;
856 p2p) type=FileTransfer;; 723 p2p) type=FileTransfer;;
857 *) type=;; 724 voip) type=Telephony;;
858 esac 725 esac
859 type="Network;${type}" 726 type="Network;${type}"
860 ;; 727 ;;
861 728
862 sci) 729 sci)
863 case ${catmin} in 730 case ${catmin} in
864 astro*) type=Astronomy;; 731 astro*) type=Astronomy;;
865 bio*) type=Biology;; 732 bio*) type=Biology;;
866 calc*) type=Calculator;; 733 calc*) type=Calculator;;
867 chem*) type=Chemistry;; 734 chem*) type=Chemistry;;
735 elec*) type=Electronics;;
868 geo*) type=Geology;; 736 geo*) type=Geology;;
869 math*) type=Math;; 737 math*) type=Math;;
870 *) type=;; 738 physics) type=Physics;;
739 visual*) type=DataVisualization;;
871 esac 740 esac
872 type="Science;${type}" 741 type="Education;Science;${type}"
742 ;;
743
744 sys)
745 type="System"
873 ;; 746 ;;
874 747
875 www) 748 www)
876 case ${catmin} in 749 case ${catmin} in
877 client) type=WebBrowser;; 750 client) type=WebBrowser;;
878 *) type=;;
879 esac 751 esac
880 type="Network" 752 type="Network;${type}"
881 ;; 753 ;;
882 754
883 *) 755 *)
884 type= 756 type=
885 ;; 757 ;;
888 if [ "${SLOT}" == "0" ] ; then 760 if [ "${SLOT}" == "0" ] ; then
889 local desktop_name="${PN}" 761 local desktop_name="${PN}"
890 else 762 else
891 local desktop_name="${PN}-${SLOT}" 763 local desktop_name="${PN}-${SLOT}"
892 fi 764 fi
893 local desktop=${T}/${exec%% *}-${desktop_name}.desktop 765 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
894# local desktop=${T}/${exec%% *:-${desktop_name}}.desktop 766 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
895 767
768 # Don't append another ";" when a valid category value is provided.
769 type=${type%;}${type:+;}
770
771 eshopts_push -s extglob
772 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
773 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
774 ewarn "allowed in .desktop files if the value is not an absolute path."
775 icon=${icon%.@(xpm|png|svg)}
776 fi
777 eshopts_pop
778
779 cat <<-EOF > "${desktop}"
896echo "[Desktop Entry] 780 [Desktop Entry]
897Encoding=UTF-8
898Version=0.9.2
899Name=${name} 781 Name=${name}
900Type=Application 782 Type=Application
901Comment=${DESCRIPTION} 783 Comment=${DESCRIPTION}
902Exec=${exec} 784 Exec=${exec}
903TryExec=${exec} 785 TryExec=${exec%% *}
904Path=${path}
905Icon=${icon} 786 Icon=${icon}
906Categories=Application;${type};" > "${desktop}" 787 Categories=${type}
788 EOF
789
790 if [[ ${fields:-=} != *=* ]] ; then
791 # 5th arg used to be value to Path=
792 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
793 fields="Path=${fields}"
794 fi
795 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
907 796
908 ( 797 (
909 # wrap the env here so that the 'insinto' call 798 # wrap the env here so that the 'insinto' call
910 # doesn't corrupt the env of the caller 799 # doesn't corrupt the env of the caller
911 insinto /usr/share/applications 800 insinto /usr/share/applications
912 doins "${desktop}" 801 doins "${desktop}"
913 ) 802 ) || die "installing desktop file failed"
914} 803}
915 804
916# Make a GDM/KDM Session file 805# @FUNCTION: validate_desktop_entries
917# 806# @USAGE: [directories]
918# make_desktop_entry(<title>, <command>) 807# @MAINTAINER:
919# title: File to execute to start the Window Manager 808# Carsten Lohrke <carlo@gentoo.org>
920# command: Name of the Window Manager 809# @DESCRIPTION:
810# Validate desktop entries using desktop-file-utils
811validate_desktop_entries() {
812 if [[ -x /usr/bin/desktop-file-validate ]] ; then
813 einfo "Checking desktop entry validity"
814 local directories=""
815 for d in /usr/share/applications $@ ; do
816 [[ -d ${D}${d} ]] && directories="${directories} ${D}${d}"
817 done
818 if [[ -n ${directories} ]] ; then
819 for FILE in $(find ${directories} -name "*\.desktop" \
820 -not -path '*.hidden*' | sort -u 2>/dev/null)
821 do
822 local temp=$(desktop-file-validate ${FILE} | grep -v "warning:" | \
823 sed -e "s|error: ||" -e "s|${FILE}:|--|g" )
824 [[ -n $temp ]] && elog ${temp/--/${FILE/${D}/}:}
825 done
826 fi
827 echo ""
828 else
829 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
830 fi
831}
921 832
833# @FUNCTION: make_session_desktop
834# @USAGE: <title> <command> [command args...]
835# @DESCRIPTION:
836# Make a GDM/KDM Session file. The title is the file to execute to start the
837# Window Manager. The command is the name of the Window Manager.
838#
839# You can set the name of the file via the ${wm} variable.
922make_session_desktop() { 840make_session_desktop() {
923 [[ -z $1 ]] && eerror "make_session_desktop: You must specify the title" && return 1 841 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
924 [[ -z $2 ]] && eerror "make_session_desktop: You must specify the command" && return 1 842 [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
925 843
926 local title=$1 844 local title=$1
927 local command=$2 845 local command=$2
928 local desktop=${T}/${wm}.desktop 846 local desktop=${T}/${wm:-${PN}}.desktop
847 shift 2
929 848
849 cat <<-EOF > "${desktop}"
930echo "[Desktop Entry] 850 [Desktop Entry]
931Encoding=UTF-8
932Name=${title} 851 Name=${title}
933Comment=This session logs you into ${title} 852 Comment=This session logs you into ${title}
934Exec=${command} 853 Exec=${command} $*
935TryExec=${command} 854 TryExec=${command}
936Type=Application" > "${desktop}" 855 Type=XSession
856 EOF
937 857
858 (
859 # wrap the env here so that the 'insinto' call
860 # doesn't corrupt the env of the caller
938 insinto /usr/share/xsessions 861 insinto /usr/share/xsessions
939 doins "${desktop}" 862 doins "${desktop}"
863 )
940} 864}
941 865
866# @FUNCTION: domenu
867# @USAGE: <menus>
868# @DESCRIPTION:
869# Install the list of .desktop menu files into the appropriate directory
870# (/usr/share/applications).
942domenu() { 871domenu() {
872 (
873 # wrap the env here so that the 'insinto' call
874 # doesn't corrupt the env of the caller
943 local i j 875 local i j ret=0
944 insinto /usr/share/applications 876 insinto /usr/share/applications
945 for i in "$@" ; do 877 for i in "$@" ; do
946 if [[ -f ${i} ]] ; then 878 if [[ -f ${i} ]] ; then
947 doins "${i}" 879 doins "${i}"
880 ((ret+=$?))
948 elif [[ -d ${i} ]] ; then 881 elif [[ -d ${i} ]] ; then
949 for j in "${i}"/*.desktop ; do 882 for j in "${i}"/*.desktop ; do
950 doins "${j}" 883 doins "${j}"
884 ((ret+=$?))
951 done 885 done
886 else
887 ((++ret))
952 fi 888 fi
953 done 889 done
890 exit ${ret}
891 )
954} 892}
893
894# @FUNCTION: newmenu
895# @USAGE: <menu> <newname>
896# @DESCRIPTION:
897# Like all other new* functions, install the specified menu as newname.
955newmenu() { 898newmenu() {
899 (
900 # wrap the env here so that the 'insinto' call
901 # doesn't corrupt the env of the caller
956 insinto /usr/share/applications 902 insinto /usr/share/applications
957 newins "$1" "$2" 903 newins "$@"
904 )
958} 905}
959 906
907# @FUNCTION: doicon
908# @USAGE: <list of icons>
909# @DESCRIPTION:
910# Install the list of icons into the icon directory (/usr/share/pixmaps).
911# This is useful in conjunction with creating desktop/menu files.
960doicon() { 912doicon() {
913 (
914 # wrap the env here so that the 'insinto' call
915 # doesn't corrupt the env of the caller
961 local i j 916 local i j ret
962 insinto /usr/share/pixmaps 917 insinto /usr/share/pixmaps
963 for i in "$@" ; do 918 for i in "$@" ; do
964 if [[ -f ${i} ]] ; then 919 if [[ -f ${i} ]] ; then
965 doins "${i}" 920 doins "${i}"
921 ((ret+=$?))
966 elif [[ -d ${i} ]] ; then 922 elif [[ -d ${i} ]] ; then
967 for j in "${i}"/*.png ; do 923 for j in "${i}"/*.png ; do
968 doins "${j}" 924 doins "${j}"
925 ((ret+=$?))
969 done 926 done
927 else
928 ((++ret))
970 fi 929 fi
971 done 930 done
931 exit ${ret}
932 )
972} 933}
934
935# @FUNCTION: newicon
936# @USAGE: <icon> <newname>
937# @DESCRIPTION:
938# Like all other new* functions, install the specified icon as newname.
973newicon() { 939newicon() {
940 (
941 # wrap the env here so that the 'insinto' call
942 # doesn't corrupt the env of the caller
974 insinto /usr/share/pixmaps 943 insinto /usr/share/pixmaps
975 newins "$1" "$2" 944 newins "$@"
945 )
976} 946}
977 947
978############################################################## 948# @FUNCTION: cdrom_get_cds
979# END: Handle .desktop files and menu entries # 949# @USAGE: <file on cd1> [file on cd2] [file on cd3] [...]
980############################################################## 950# @DESCRIPTION:
981
982
983# for internal use only (unpack_pdv and unpack_makeself)
984find_unpackable_file() {
985 local src=$1
986 if [[ -z ${src} ]] ; then
987 src=${DISTDIR}/${A}
988 else
989 if [[ -e ${DISTDIR}/${src} ]] ; then
990 src=${DISTDIR}/${src}
991 elif [[ -e ${PWD}/${src} ]] ; then
992 src=${PWD}/${src}
993 elif [[ -e ${src} ]] ; then
994 src=${src}
995 fi
996 fi
997 [[ ! -e ${src} ]] && return 1
998 echo "${src}"
999}
1000
1001# Unpack those pesky pdv generated files ...
1002# They're self-unpacking programs with the binary package stuffed in
1003# the middle of the archive. Valve seems to use it a lot ... too bad
1004# it seems to like to segfault a lot :(. So lets take it apart ourselves.
1005#
1006# Usage: unpack_pdv [file to unpack] [size of off_t]
1007# - you have to specify the off_t size ... i have no idea how to extract that
1008# information out of the binary executable myself. basically you pass in
1009# the size of the off_t type (in bytes) on the machine that built the pdv
1010# archive. one way to determine this is by running the following commands:
1011# strings <pdv archive> | grep lseek
1012# strace -elseek <pdv archive>
1013# basically look for the first lseek command (we do the strings/grep because
1014# sometimes the function call is _llseek or something) and steal the 2nd
1015# parameter. here is an example:
1016# root@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek
1017# lseek
1018# root@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin
1019# lseek(3, -4, SEEK_END) = 2981250
1020# thus we would pass in the value of '4' as the second parameter.
1021unpack_pdv() {
1022 local src=$(find_unpackable_file $1)
1023 local sizeoff_t=$2
1024
1025 [[ -z ${src} ]] && die "Could not locate source for '$1'"
1026 [[ -z ${sizeoff_t} ]] && die "No idea what off_t size was used for this pdv :("
1027
1028 local shrtsrc=$(basename "${src}")
1029 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1030 local metaskip=`tail -c ${sizeoff_t} ${src} | hexdump -e \"%i\"`
1031 local tailskip=`tail -c $((${sizeoff_t}*2)) ${src} | head -c ${sizeoff_t} | hexdump -e \"%i\"`
1032
1033 # grab metadata for debug reasons
1034 local metafile="$(emktemp)"
1035 tail -c +$((${metaskip}+1)) ${src} > ${metafile}
1036
1037 # rip out the final file name from the metadata
1038 local datafile="`tail -c +$((${metaskip}+1)) ${src} | strings | head -n 1`"
1039 datafile="`basename ${datafile}`"
1040
1041 # now lets uncompress/untar the file if need be
1042 local tmpfile="$(emktemp)"
1043 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null | head -c 512 > ${tmpfile}
1044
1045 local iscompressed="`file -b ${tmpfile}`"
1046 if [ "${iscompressed:0:8}" == "compress" ] ; then
1047 iscompressed=1
1048 mv ${tmpfile}{,.Z}
1049 gunzip ${tmpfile}
1050 else
1051 iscompressed=0
1052 fi
1053 local istar="`file -b ${tmpfile}`"
1054 if [ "${istar:0:9}" == "POSIX tar" ] ; then
1055 istar=1
1056 else
1057 istar=0
1058 fi
1059
1060 #for some reason gzip dies with this ... dd cant provide buffer fast enough ?
1061 #dd if=${src} ibs=${metaskip} count=1 \
1062 # | dd ibs=${tailskip} skip=1 \
1063 # | gzip -dc \
1064 # > ${datafile}
1065 if [ ${iscompressed} -eq 1 ] ; then
1066 if [ ${istar} -eq 1 ] ; then
1067 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1068 | head -c $((${metaskip}-${tailskip})) \
1069 | tar -xzf -
1070 else
1071 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1072 | head -c $((${metaskip}-${tailskip})) \
1073 | gzip -dc \
1074 > ${datafile}
1075 fi
1076 else
1077 if [ ${istar} -eq 1 ] ; then
1078 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1079 | head -c $((${metaskip}-${tailskip})) \
1080 | tar --no-same-owner -xf -
1081 else
1082 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1083 | head -c $((${metaskip}-${tailskip})) \
1084 > ${datafile}
1085 fi
1086 fi
1087 true
1088 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1089 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1090}
1091
1092# Unpack those pesky makeself generated files ...
1093# They're shell scripts with the binary package tagged onto
1094# the end of the archive. Loki utilized the format as does
1095# many other game companies.
1096#
1097# Usage: unpack_makeself [file to unpack] [offset] [tail|dd]
1098# - If the file is not specified then unpack will utilize ${A}.
1099# - If the offset is not specified then we will attempt to extract
1100# the proper offset from the script itself.
1101unpack_makeself() {
1102 local src_input=${1:-${A}}
1103 local src=$(find_unpackable_file "${src_input}")
1104 local skip=$2
1105 local exe=$3
1106
1107 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'"
1108
1109 local shrtsrc=$(basename "${src}")
1110 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1111 if [[ -z ${skip} ]] ; then
1112 local ver=$(grep -a '#.*Makeself' "${src}" | awk '{print $NF}')
1113 local skip=0
1114 exe=tail
1115 case ${ver} in
1116 1.5.*) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same
1117 skip=$(grep -a ^skip= "${src}" | cut -d= -f2)
1118 ;;
1119 2.0|2.0.1)
1120 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-)
1121 ;;
1122 2.1.1)
1123 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-)
1124 let skip="skip + 1"
1125 ;;
1126 2.1.2)
1127 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1)
1128 let skip="skip + 1"
1129 ;;
1130 2.1.3)
1131 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
1132 let skip="skip + 1"
1133 ;;
1134 2.1.4|2.1.5)
1135 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1136 skip=$(head -n ${skip} "${src}" | wc -c)
1137 exe="dd"
1138 ;;
1139 *)
1140 eerror "I'm sorry, but I was unable to support the Makeself file."
1141 eerror "The version I detected was '${ver}'."
1142 eerror "Please file a bug about the file ${shrtsrc} at"
1143 eerror "http://bugs.gentoo.org/ so that support can be added."
1144 die "makeself version '${ver}' not supported"
1145 ;;
1146 esac
1147 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset"
1148 fi
1149 case ${exe} in
1150 tail) exe="tail -n +${skip} '${src}'";;
1151 dd) exe="dd ibs=${skip} skip=1 obs=1024 conv=sync if='${src}'";;
1152 *) die "makeself cant handle exe '${exe}'"
1153 esac
1154
1155 # lets grab the first few bytes of the file to figure out what kind of archive it is
1156 local tmpfile="$(emktemp)"
1157 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}"
1158 local filetype="$(file -b "${tmpfile}")"
1159 case ${filetype} in
1160 *tar\ archive)
1161 eval ${exe} | tar --no-same-owner -xf -
1162 ;;
1163 bzip2*)
1164 eval ${exe} | bzip2 -dc | tar --no-same-owner -xf -
1165 ;;
1166 gzip*)
1167 eval ${exe} | tar --no-same-owner -xzf -
1168 ;;
1169 compress*)
1170 eval ${exe} | gunzip | tar --no-same-owner -xf -
1171 ;;
1172 *)
1173 eerror "Unknown filetype \"${filetype}\" ?"
1174 false
1175 ;;
1176 esac
1177 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})"
1178}
1179
1180# Display a license for user to accept.
1181#
1182# Usage: check_license [license]
1183# - If the file is not specified then ${LICENSE} is used.
1184check_license() {
1185 local lic=$1
1186 if [ -z "${lic}" ] ; then
1187 lic="${PORTDIR}/licenses/${LICENSE}"
1188 else
1189 if [ -e "${PORTDIR}/licenses/${lic}" ] ; then
1190 lic="${PORTDIR}/licenses/${lic}"
1191 elif [ -e "${PWD}/${lic}" ] ; then
1192 lic="${PWD}/${lic}"
1193 elif [ -e "${lic}" ] ; then
1194 lic="${lic}"
1195 fi
1196 fi
1197 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1198 local l="`basename ${lic}`"
1199
1200 # here is where we check for the licenses the user already
1201 # accepted ... if we don't find a match, we make the user accept
1202 local shopts=$-
1203 local alic
1204 set -o noglob #so that bash doesn't expand "*"
1205 for alic in ${ACCEPT_LICENSE} ; do
1206 if [[ ${alic} == * || ${alic} == ${l} ]]; then
1207 set +o noglob; set -${shopts} #reset old shell opts
1208 return 0
1209 fi
1210 done
1211 set +o noglob; set -$shopts #reset old shell opts
1212
1213 local licmsg="$(emktemp)"
1214 cat << EOF > ${licmsg}
1215**********************************************************
1216The following license outlines the terms of use of this
1217package. You MUST accept this license for installation to
1218continue. When you are done viewing, hit 'q'. If you
1219CTRL+C out of this, the install will not run!
1220**********************************************************
1221
1222EOF
1223 cat ${lic} >> ${licmsg}
1224 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}"
1225 einfon "Do you accept the terms of this license (${l})? [yes/no] "
1226 read alic
1227 case ${alic} in
1228 yes|Yes|y|Y)
1229 return 0
1230 ;;
1231 *)
1232 echo;echo;echo
1233 eerror "You MUST accept the license to continue! Exiting!"
1234 die "Failed to accept license"
1235 ;;
1236 esac
1237}
1238
1239# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates 951# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates
1240# the whole 'non-interactive' policy, but damnit I want CD support ! 952# the whole 'non-interactive' policy, but damnit I want CD support !
1241# 953#
1242# with these cdrom functions we handle all the user interaction and 954# With these cdrom functions we handle all the user interaction and
1243# standardize everything. all you have to do is call cdrom_get_cds() 955# standardize everything. All you have to do is call cdrom_get_cds()
1244# and when the function returns, you can assume that the cd has been 956# and when the function returns, you can assume that the cd has been
1245# found at CDROM_ROOT. 957# found at CDROM_ROOT.
1246# 958#
959# The function will attempt to locate a cd based upon a file that is on
960# the cd. The more files you give this function, the more cds
961# the cdrom functions will handle.
962#
1247# normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2', 963# Normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2',
1248# etc... if you want to give the cds better names, then just export 964# etc... If you want to give the cds better names, then just export
1249# the CDROM_NAME_X variables before calling cdrom_get_cds(). 965# the appropriate CDROM_NAME variable before calling cdrom_get_cds().
966# Use CDROM_NAME for one cd, or CDROM_NAME_# for multiple cds. You can
967# also use the CDROM_NAME_SET bash array.
1250# 968#
1251# for those multi cd ebuilds, see the cdrom_load_next_cd() below. 969# For those multi cd ebuilds, see the cdrom_load_next_cd() function.
1252#
1253# Usage: cdrom_get_cds <file on cd1> [file on cd2] [file on cd3] [...]
1254# - this will attempt to locate a cd based upon a file that is on
1255# the cd ... the more files you give this function, the more cds
1256# the cdrom functions will handle
1257cdrom_get_cds() { 970cdrom_get_cds() {
1258 # first we figure out how many cds we're dealing with by 971 # first we figure out how many cds we're dealing with by
1259 # the # of files they gave us 972 # the # of files they gave us
1260 local cdcnt=0 973 local cdcnt=0
1261 local f= 974 local f=
1285 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}} 998 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}}
1286 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}" 999 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1287 export CDROM_SET=-1 1000 export CDROM_SET=-1
1288 for f in ${CDROM_CHECK_1//:/ } ; do 1001 for f in ${CDROM_CHECK_1//:/ } ; do
1289 ((++CDROM_SET)) 1002 ((++CDROM_SET))
1290 [[ -e ${CD_ROOT}/${f} ]] && break 1003 [[ -e ${CDROM_ROOT}/${f} ]] && break
1291 done 1004 done
1292 export CDROM_MATCH=${f} 1005 export CDROM_MATCH=${f}
1293 return 1006 return
1294 fi 1007 fi
1295 1008
1305 echo 1018 echo
1306 einfo "For example:" 1019 einfo "For example:"
1307 einfo "export CD_ROOT=/mnt/cdrom" 1020 einfo "export CD_ROOT=/mnt/cdrom"
1308 echo 1021 echo
1309 else 1022 else
1023 if [[ -n ${CDROM_NAME_SET} ]] ; then
1024 # Translate the CDROM_NAME_SET array into CDROM_NAME_#
1025 cdcnt=0
1026 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1027 ((++cdcnt))
1028 export CDROM_NAME_${cdcnt}="${CDROM_NAME_SET[$((${cdcnt}-1))]}"
1029 done
1030 fi
1031
1310 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds." 1032 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds."
1311 cdcnt=0 1033 cdcnt=0
1312 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do 1034 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1313 ((++cdcnt)) 1035 ((++cdcnt))
1314 var="CDROM_NAME_${cdcnt}" 1036 var="CDROM_NAME_${cdcnt}"
1338 export CDROM_SET="" 1060 export CDROM_SET=""
1339 export CDROM_CURRENT_CD=0 1061 export CDROM_CURRENT_CD=0
1340 cdrom_load_next_cd 1062 cdrom_load_next_cd
1341} 1063}
1342 1064
1343# this is only used when you need access to more than one cd. 1065# @FUNCTION: cdrom_load_next_cd
1344# when you have finished using the first cd, just call this function. 1066# @DESCRIPTION:
1345# when it returns, CDROM_ROOT will be pointing to the second cd. 1067# Some packages are so big they come on multiple CDs. When you're done reading
1346# remember, you can only go forward in the cd chain, you can't go back. 1068# files off a CD and want access to the next one, just call this function.
1069# Again, all the messy details of user interaction are taken care of for you.
1070# Once this returns, just read the variable CDROM_ROOT for the location of the
1071# mounted CD. Note that you can only go forward in the CD list, so make sure
1072# you only call this function when you're done using the current CD.
1347cdrom_load_next_cd() { 1073cdrom_load_next_cd() {
1348 local var 1074 local var
1349 ((++CDROM_CURRENT_CD)) 1075 ((++CDROM_CURRENT_CD))
1350 1076
1351 unset CDROM_ROOT 1077 unset CDROM_ROOT
1368# displayed and we'll hang out here until: 1094# displayed and we'll hang out here until:
1369# (1) the file is found on a mounted cdrom 1095# (1) the file is found on a mounted cdrom
1370# (2) the user hits CTRL+C 1096# (2) the user hits CTRL+C
1371_cdrom_locate_file_on_cd() { 1097_cdrom_locate_file_on_cd() {
1372 local mline="" 1098 local mline=""
1373 local showedmsg=0 1099 local showedmsg=0 showjolietmsg=0
1374 1100
1375 while [[ -z ${CDROM_ROOT} ]] ; do 1101 while [[ -z ${CDROM_ROOT} ]] ; do
1376 local i=0 1102 local i=0
1377 local -a cdset=(${*//:/ }) 1103 local -a cdset=(${*//:/ })
1378 if [[ -n ${CDROM_SET} ]] ; then 1104 if [[ -n ${CDROM_SET} ]] ; then
1381 1107
1382 while [[ -n ${cdset[${i}]} ]] ; do 1108 while [[ -n ${cdset[${i}]} ]] ; do
1383 local dir=$(dirname ${cdset[${i}]}) 1109 local dir=$(dirname ${cdset[${i}]})
1384 local file=$(basename ${cdset[${i}]}) 1110 local file=$(basename ${cdset[${i}]})
1385 1111
1386 for mline in $(mount | gawk '/(iso|cdrom|fs=cdfss)/ {print $3}') ; do 1112 local point= node= fs= foo=
1113 while read point node fs foo ; do
1114 [[ " cd9660 iso9660 udf " != *" ${fs} "* ]] && \
1115 ! [[ ${fs} == "subfs" && ",${opts}," == *",fs=cdfss,"* ]] \
1116 && continue
1117 point=${point//\040/ }
1387 [[ -d ${mline}/${dir} ]] || continue 1118 [[ ! -d ${point}/${dir} ]] && continue
1388 if [[ -n $(find ${mline}/${dir} -maxdepth 1 -iname ${file}) ]] ; then 1119 [[ -z $(find "${point}/${dir}" -maxdepth 1 -iname "${file}") ]] && continue
1389 export CDROM_ROOT=${mline} 1120 export CDROM_ROOT=${point}
1390 export CDROM_SET=${i} 1121 export CDROM_SET=${i}
1391 export CDROM_MATCH=${cdset[${i}]} 1122 export CDROM_MATCH=${cdset[${i}]}
1392 return 1123 return
1393 fi 1124 done <<< "$(get_mounts)"
1394 done
1395 1125
1396 ((++i)) 1126 ((++i))
1397 done 1127 done
1398 1128
1399 echo 1129 echo
1415 showedmsg=1 1145 showedmsg=1
1416 fi 1146 fi
1417 einfo "Press return to scan for the cd again" 1147 einfo "Press return to scan for the cd again"
1418 einfo "or hit CTRL+C to abort the emerge." 1148 einfo "or hit CTRL+C to abort the emerge."
1419 echo 1149 echo
1150 if [[ ${showjolietmsg} -eq 0 ]] ; then
1151 showjolietmsg=1
1152 else
1420 einfo "If you are having trouble with the detection" 1153 ewarn "If you are having trouble with the detection"
1421 einfo "of your CD, it is possible that you do not have" 1154 ewarn "of your CD, it is possible that you do not have"
1422 einfo "Joliet support enabled in your kernel. Please" 1155 ewarn "Joliet support enabled in your kernel. Please"
1423 einfo "check that CONFIG_JOLIET is enabled in your kernel." 1156 ewarn "check that CONFIG_JOLIET is enabled in your kernel."
1157 ebeep 5
1158 fi
1424 read || die "something is screwed with your system" 1159 read || die "something is screwed with your system"
1425 done 1160 done
1426} 1161}
1427 1162
1163# @FUNCTION: strip-linguas
1164# @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>]
1165# @DESCRIPTION:
1428# Make sure that LINGUAS only contains languages that 1166# Make sure that LINGUAS only contains languages that
1429# a package can support 1167# a package can support. The first form allows you to
1430# 1168# specify a list of LINGUAS. The -i builds a list of po
1431# usage: strip-linguas <allow LINGUAS> 1169# files found in all the directories and uses the
1432# strip-linguas -i <directories of .po files> 1170# intersection of the lists. The -u builds a list of po
1433# strip-linguas -u <directories of .po files> 1171# files found in all the directories and uses the union
1434# 1172# of the lists.
1435# The first form allows you to specify a list of LINGUAS.
1436# The -i builds a list of po files found in all the
1437# directories and uses the intersection of the lists.
1438# The -u builds a list of po files found in all the
1439# directories and uses the union of the lists.
1440strip-linguas() { 1173strip-linguas() {
1441 local ls newls 1174 local ls newls nols
1442 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then 1175 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1443 local op=$1; shift 1176 local op=$1; shift
1444 ls=$(find "$1" -name '*.po' -exec basename {} .po \;); shift 1177 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1445 local d f 1178 local d f
1446 for d in "$@" ; do 1179 for d in "$@" ; do
1447 if [[ ${op} == "-u" ]] ; then 1180 if [[ ${op} == "-u" ]] ; then
1448 newls=${ls} 1181 newls=${ls}
1449 else 1182 else
1450 newls="" 1183 newls=""
1451 fi 1184 fi
1452 for f in $(find "$d" -name '*.po' -exec basename {} .po \;) ; do 1185 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1453 if [[ ${op} == "-i" ]] ; then 1186 if [[ ${op} == "-i" ]] ; then
1454 hasq ${f} ${ls} && newls="${newls} ${f}" 1187 has ${f} ${ls} && newls="${newls} ${f}"
1455 else 1188 else
1456 hasq ${f} ${ls} || newls="${newls} ${f}" 1189 has ${f} ${ls} || newls="${newls} ${f}"
1457 fi 1190 fi
1458 done 1191 done
1459 ls=${newls} 1192 ls=${newls}
1460 done 1193 done
1461 else 1194 else
1462 ls="$@" 1195 ls="$@"
1463 fi 1196 fi
1464 1197
1198 nols=""
1465 newls="" 1199 newls=""
1466 for f in ${LINGUAS} ; do 1200 for f in ${LINGUAS} ; do
1467 if hasq ${f} ${ls} ; then 1201 if has ${f} ${ls} ; then
1468 newls="${newls} ${f}" 1202 newls="${newls} ${f}"
1469 else 1203 else
1470 ewarn "Sorry, but ${PN} does not support the ${f} LINGUA" 1204 nols="${nols} ${f}"
1471 fi 1205 fi
1472 done 1206 done
1207 [[ -n ${nols} ]] \
1208 && ewarn "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1473 export LINGUAS=${newls:1} 1209 export LINGUAS=${newls:1}
1474} 1210}
1475 1211
1476# moved from kernel.eclass since they are generally useful outside of 1212# @FUNCTION: preserve_old_lib
1477# kernel.eclass -iggy (20041002) 1213# @USAGE: <libs to preserve> [more libs]
1478 1214# @DESCRIPTION:
1479# the following functions are useful in kernel module ebuilds, etc.
1480# for an example see ivtv or drbd ebuilds
1481
1482# set's ARCH to match what the kernel expects
1483set_arch_to_kernel() {
1484 i=10
1485 while ((i--)) ; do
1486 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1487 done
1488 export EUTILS_ECLASS_PORTAGE_ARCH="${ARCH}"
1489 case ${ARCH} in
1490 x86) export ARCH="i386";;
1491 amd64) export ARCH="x86_64";;
1492 hppa) export ARCH="parisc";;
1493 mips) export ARCH="mips";;
1494 sparc) export ARCH="$(tc-arch-kernel)";; # Yeah this is ugly, but it's even WORSE if you don't do this. linux-info.eclass's set_arch_to_kernel is fixed, but won't get used over this one!
1495 *) export ARCH="${ARCH}";;
1496 esac
1497}
1498
1499# set's ARCH back to what portage expects
1500set_arch_to_portage() {
1501 i=10
1502 while ((i--)) ; do
1503 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1504 done
1505 export ARCH="${EUTILS_ECLASS_PORTAGE_ARCH}"
1506}
1507
1508# Jeremy Huddleston <eradicator@gentoo.org>:
1509# preserve_old_lib /path/to/libblah.so.0
1510# preserve_old_lib_notify /path/to/libblah.so.0
1511#
1512# These functions are useful when a lib in your package changes --library. Such 1215# These functions are useful when a lib in your package changes ABI SONAME.
1513# an example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0 1216# An example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0
1514# would break packages that link against it. Most people get around this 1217# would break packages that link against it. Most people get around this
1515# by using the portage SLOT mechanism, but that is not always a relevant 1218# by using the portage SLOT mechanism, but that is not always a relevant
1516# solution, so instead you can add the following to your ebuilds: 1219# solution, so instead you can call this from pkg_preinst. See also the
1517# 1220# preserve_old_lib_notify function.
1518# src_install() {
1519# ...
1520# preserve_old_lib /usr/$(get_libdir)/libogg.so.0
1521# ...
1522# }
1523#
1524# pkg_postinst() {
1525# ...
1526# preserve_old_lib_notify /usr/$(get_libdir)/libogg.so.0
1527# ...
1528# }
1529
1530preserve_old_lib() { 1221preserve_old_lib() {
1531 LIB=$1 1222 if [[ ${EBUILD_PHASE} != "preinst" ]] ; then
1223 eerror "preserve_old_lib() must be called from pkg_preinst() only"
1224 die "Invalid preserve_old_lib() usage"
1225 fi
1226 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]"
1532 1227
1533 if [ -n "${LIB}" -a -f "${ROOT}${LIB}" ]; then 1228 # let portage worry about it
1534 SONAME=`basename ${LIB}` 1229 has preserve-libs ${FEATURES} && return 0
1535 DIRNAME=`dirname ${LIB}`
1536 1230
1537 dodir ${DIRNAME} 1231 local lib dir
1538 cp ${ROOT}${LIB} ${D}${DIRNAME} 1232 for lib in "$@" ; do
1233 [[ -e ${ROOT}/${lib} ]] || continue
1234 dir=${lib%/*}
1235 dodir ${dir} || die "dodir ${dir} failed"
1236 cp "${ROOT}"/${lib} "${D}"/${lib} || die "cp ${lib} failed"
1539 touch ${D}${LIB} 1237 touch "${D}"/${lib}
1540 fi 1238 done
1541} 1239}
1542 1240
1241# @FUNCTION: preserve_old_lib_notify
1242# @USAGE: <libs to notify> [more libs]
1243# @DESCRIPTION:
1244# Spit helpful messages about the libraries preserved by preserve_old_lib.
1543preserve_old_lib_notify() { 1245preserve_old_lib_notify() {
1544 LIB=$1 1246 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then
1247 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only"
1248 die "Invalid preserve_old_lib_notify() usage"
1249 fi
1545 1250
1546 if [ -n "${LIB}" -a -f "${ROOT}${LIB}" ]; then 1251 # let portage worry about it
1547 SONAME=`basename ${LIB}` 1252 has preserve-libs ${FEATURES} && return 0
1548 1253
1254 local lib notice=0
1255 for lib in "$@" ; do
1256 [[ -e ${ROOT}/${lib} ]] || continue
1257 if [[ ${notice} -eq 0 ]] ; then
1258 notice=1
1549 ewarn "An old version of an installed library was detected on your system." 1259 ewarn "Old versions of installed libraries were detected on your system."
1550 ewarn "In order to avoid breaking packages that link against it, this older version" 1260 ewarn "In order to avoid breaking packages that depend on these old libs,"
1551 ewarn "is not being removed. In order to make full use of this newer version," 1261 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1552 ewarn "you will need to execute the following command:" 1262 ewarn "in order to remove these old dependencies. If you do not have this"
1263 ewarn "helper program, simply emerge the 'gentoolkit' package."
1264 ewarn
1265 fi
1266 # temp hack for #348634 #357225
1267 [[ ${PN} == "mpfr" ]] && lib=${lib##*/}
1553 ewarn " revdep-rebuild --library ${SONAME}" 1268 ewarn " # revdep-rebuild --library '${lib}'"
1269 done
1270 if [[ ${notice} -eq 1 ]] ; then
1554 ewarn 1271 ewarn
1555 ewarn "After doing that, you can safely remove ${LIB}" 1272 ewarn "Once you've finished running revdep-rebuild, it should be safe to"
1556 ewarn "Note: 'emerge gentoolkit' to get revdep-rebuild" 1273 ewarn "delete the old libraries. Here is a copy & paste for the lazy:"
1274 for lib in "$@" ; do
1275 ewarn " # rm '${lib}'"
1276 done
1557 fi 1277 fi
1558} 1278}
1559 1279
1560# Hack for people to figure out if a package was built with 1280# @FUNCTION: built_with_use
1561# certain USE flags 1281# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1282# @DESCRIPTION:
1562# 1283#
1563# Usage: built_with_use [-a|-o] <DEPEND ATOM> <List of USE flags> 1284# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1564# ex: built_with_use xchat gtk2
1565# 1285#
1566# Flags: -a all USE flags should be utilized 1286# A temporary hack until portage properly supports DEPENDing on USE
1567# -o at least one USE flag should be utilized 1287# flags being enabled in packages. This will check to see if the specified
1568# Note: the default flag is '-a' 1288# DEPEND atom was built with the specified list of USE flags. The
1289# --missing option controls the behavior if called on a package that does
1290# not actually support the defined USE flags (aka listed in IUSE).
1291# The default is to abort (call die). The -a and -o flags control
1292# the requirements of the USE flags. They correspond to "and" and "or"
1293# logic. So the -a flag means all listed USE flags must be enabled
1294# while the -o flag means at least one of the listed IUSE flags must be
1295# enabled. The --hidden option is really for internal use only as it
1296# means the USE flag we're checking is hidden expanded, so it won't be found
1297# in IUSE like normal USE flags.
1298#
1299# Remember that this function isn't terribly intelligent so order of optional
1300# flags matter.
1569built_with_use() { 1301built_with_use() {
1302 local hidden="no"
1303 if [[ $1 == "--hidden" ]] ; then
1304 hidden="yes"
1305 shift
1306 fi
1307
1308 local missing_action="die"
1309 if [[ $1 == "--missing" ]] ; then
1310 missing_action=$2
1311 shift ; shift
1312 case ${missing_action} in
1313 true|false|die) ;;
1314 *) die "unknown action '${missing_action}'";;
1315 esac
1316 fi
1317
1570 local opt=$1 1318 local opt=$1
1571 [[ ${opt:0:1} = "-" ]] && shift || opt="-a" 1319 [[ ${opt:0:1} = "-" ]] && shift || opt="-a"
1572 1320
1573 local PKG=$(best_version $1) 1321 local PKG=$(best_version $1)
1322 [[ -z ${PKG} ]] && die "Unable to resolve $1 to an installed package"
1574 shift 1323 shift
1575 1324
1576 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE 1325 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE
1326 local IUSEFILE=${ROOT}/var/db/pkg/${PKG}/IUSE
1577 1327
1578 # if the USE file doesnt exist, assume the $PKG is either 1328 # if the IUSE file doesn't exist, the read will error out, we need to handle
1579 # injected or package.provided 1329 # this gracefully
1580 [[ ! -e ${USEFILE} ]] && return 0 1330 if [[ ! -e ${USEFILE} ]] || [[ ! -e ${IUSEFILE} && ${hidden} == "no" ]] ; then
1331 case ${missing_action} in
1332 true) return 0;;
1333 false) return 1;;
1334 die) die "Unable to determine what USE flags $PKG was built with";;
1335 esac
1336 fi
1337
1338 if [[ ${hidden} == "no" ]] ; then
1339 local IUSE_BUILT=( $(<"${IUSEFILE}") )
1340 # Don't check USE_EXPAND #147237
1341 local expand
1342 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do
1343 if [[ $1 == ${expand}_* ]] ; then
1344 expand=""
1345 break
1346 fi
1347 done
1348 if [[ -n ${expand} ]] ; then
1349 if ! has $1 ${IUSE_BUILT[@]#[-+]} ; then
1350 case ${missing_action} in
1351 true) return 0;;
1352 false) return 1;;
1353 die) die "$PKG does not actually support the $1 USE flag!";;
1354 esac
1355 fi
1356 fi
1357 fi
1581 1358
1582 local USE_BUILT=$(<${USEFILE}) 1359 local USE_BUILT=$(<${USEFILE})
1583 while [[ $# -gt 0 ]] ; do 1360 while [[ $# -gt 0 ]] ; do
1584 if [[ ${opt} = "-o" ]] ; then 1361 if [[ ${opt} = "-o" ]] ; then
1585 has $1 ${USE_BUILT} && return 0 1362 has $1 ${USE_BUILT} && return 0
1589 shift 1366 shift
1590 done 1367 done
1591 [[ ${opt} = "-a" ]] 1368 [[ ${opt} = "-a" ]]
1592} 1369}
1593 1370
1371# @FUNCTION: epunt_cxx
1372# @USAGE: [dir to scan]
1373# @DESCRIPTION:
1594# Many configure scripts wrongly bail when a C++ compiler 1374# Many configure scripts wrongly bail when a C++ compiler could not be
1595# could not be detected. #73450 1375# detected. If dir is not specified, then it defaults to ${S}.
1376#
1377# http://bugs.gentoo.org/73450
1596epunt_cxx() { 1378epunt_cxx() {
1597 local dir=$1 1379 local dir=$1
1598 [[ -z ${dir} ]] && dir=${S} 1380 [[ -z ${dir} ]] && dir=${S}
1599 ebegin "Removing useless C++ checks" 1381 ebegin "Removing useless C++ checks"
1600 local f 1382 local f
1601 for f in $(find ${dir} -name configure) ; do 1383 find "${dir}" -name configure | while read f ; do
1602 patch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null 1384 patch --no-backup-if-mismatch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null
1603 done 1385 done
1604 eend 0 1386 eend 0
1605} 1387}
1606 1388
1607# dopamd <file> [more files] 1389# @FUNCTION: make_wrapper
1608# 1390# @USAGE: <wrapper> <target> [chdir] [libpaths] [installpath]
1609# Install pam auth config file in /etc/pam.d 1391# @DESCRIPTION:
1610dopamd() { 1392# Create a shell wrapper script named wrapper in installpath
1611 [[ -z $1 ]] && die "dopamd requires at least one argument" 1393# (defaults to the bindir) to execute target (default of wrapper) by
1612 1394# first optionally setting LD_LIBRARY_PATH to the colon-delimited
1613 use pam || return 0 1395# libpaths followed by optionally changing directory to chdir.
1614
1615 INSDESTTREE=/etc/pam.d \
1616 doins "$@" || die "failed to install $@"
1617}
1618# newpamd <old name> <new name>
1619#
1620# Install pam file <old name> as <new name> in /etc/pam.d
1621newpamd() {
1622 [[ $# -ne 2 ]] && die "newpamd requires two arguements"
1623
1624 use pam || return 0
1625
1626 INSDESTTREE=/etc/pam.d \
1627 newins "$1" "$2" || die "failed to install $1 as $2"
1628}
1629
1630# make a wrapper script ...
1631# NOTE: this was originally games_make_wrapper, but I noticed other places where
1632# this could be used, so I have moved it here and made it not games-specific
1633# -- wolf31o2
1634# $1 == wrapper name
1635# $2 == binary to run
1636# $3 == directory to chdir before running binary
1637# $4 == extra LD_LIBRARY_PATH's (make it : delimited)
1638# $5 == path for wrapper
1639make_wrapper() { 1396make_wrapper() {
1640 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5 1397 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
1641 local tmpwrapper=$(emktemp) 1398 local tmpwrapper=$(emktemp)
1642 # We don't want to quote ${bin} so that people can pass complex 1399 # We don't want to quote ${bin} so that people can pass complex
1643 # things as $bin ... "./someprog --args" 1400 # things as $bin ... "./someprog --args"
1653fi 1410fi
1654exec ${bin} "\$@" 1411exec ${bin} "\$@"
1655EOF 1412EOF
1656 chmod go+rx "${tmpwrapper}" 1413 chmod go+rx "${tmpwrapper}"
1657 if [[ -n ${path} ]] ; then 1414 if [[ -n ${path} ]] ; then
1415 (
1658 exeinto "${path}" 1416 exeinto "${path}"
1659 newexe "${tmpwrapper}" "${wrapper}" 1417 newexe "${tmpwrapper}" "${wrapper}"
1418 ) || die
1660 else 1419 else
1661 newbin "${tmpwrapper}" "${wrapper}" 1420 newbin "${tmpwrapper}" "${wrapper}" || die
1421 fi
1422}
1423
1424# @FUNCTION: path_exists
1425# @USAGE: [-a|-o] <paths>
1426# @DESCRIPTION:
1427# Check if the specified paths exist. Works for all types of paths
1428# (files/dirs/etc...). The -a and -o flags control the requirements
1429# of the paths. They correspond to "and" and "or" logic. So the -a
1430# flag means all the paths must exist while the -o flag means at least
1431# one of the paths must exist. The default behavior is "and". If no
1432# paths are specified, then the return value is "false".
1433path_exists() {
1434 local opt=$1
1435 [[ ${opt} == -[ao] ]] && shift || opt="-a"
1436
1437 # no paths -> return false
1438 # same behavior as: [[ -e "" ]]
1439 [[ $# -eq 0 ]] && return 1
1440
1441 local p r=0
1442 for p in "$@" ; do
1443 [[ -e ${p} ]]
1444 : $(( r += $? ))
1445 done
1446
1447 case ${opt} in
1448 -a) return $(( r != 0 )) ;;
1449 -o) return $(( r == $# )) ;;
1450 esac
1451}
1452
1453# @FUNCTION: in_iuse
1454# @USAGE: <flag>
1455# @DESCRIPTION:
1456# Determines whether the given flag is in IUSE. Strips IUSE default prefixes
1457# as necessary.
1458#
1459# Note that this function should not be used in the global scope.
1460in_iuse() {
1461 debug-print-function ${FUNCNAME} "${@}"
1462 [[ ${#} -eq 1 ]] || die "Invalid args to ${FUNCNAME}()"
1463
1464 local flag=${1}
1465 local liuse=( ${IUSE} )
1466
1467 has "${flag}" "${liuse[@]#[+-]}"
1468}
1469
1470# @FUNCTION: use_if_iuse
1471# @USAGE: <flag>
1472# @DESCRIPTION:
1473# Return true if the given flag is in USE and IUSE.
1474#
1475# Note that this function should not be used in the global scope.
1476use_if_iuse() {
1477 in_iuse $1 || return 1
1478 use $1
1479}
1480
1481# @FUNCTION: usex
1482# @USAGE: <USE flag> [true output] [false output] [true suffix] [false suffix]
1483# @DESCRIPTION:
1484# If USE flag is set, echo [true output][true suffix] (defaults to "yes"),
1485# otherwise echo [false output][false suffix] (defaults to "no").
1486usex() { use "$1" && echo "${2-yes}$4" || echo "${3-no}$5" ; } #382963
1487
1488check_license() { die "you no longer need this as portage supports ACCEPT_LICENSE itself"; }
1489
1662 fi 1490fi
1663}

Legend:
Removed from v.1.237  
changed lines
  Added in v.1.382

  ViewVC Help
Powered by ViewVC 1.1.20